package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlockWorld;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.event.player.PlayerPortalEvent;

import java.util.Objects;

public class ExitPixelWorldListener implements Listener {
    @EventHandler
    static void onPlayerChangeWorld(PlayerChangedWorldEvent event) {
        World changingFrom = event.getFrom();
        if(!PixelBlockWorld.isPixelWorld(changingFrom)) return;

        PixelBlock pixelBlock = PixelBlock.getPixelBlockFromBlockWorld(changingFrom);
        Objects.requireNonNull(pixelBlock);
        pixelBlock.updateEntities();
    }

    @EventHandler
    static void onPlayerPortal(PlayerPortalEvent event) {
        World pixelBlockWorld = event.getFrom().getWorld();

        if(!PixelBlockWorld.isPixelWorld(pixelBlockWorld)) return;

        event.setCancelled(true);
        PixelBlock pixelBlock = PixelBlock.getPixelBlockFromBlockWorld(pixelBlockWorld);
        Objects.requireNonNull(pixelBlock);
        event.getPlayer().teleport(pixelBlock.lastEntryLocation);
    }
}
